import { TNSParticleAPI, TNSParticleDevice, TNSParticleEvent, TNSParticleLoginOptions } from "./particle.common";
export declare class Particle implements TNSParticleAPI {
    private wizardDelegate;
    private eventIds;
    login(options: TNSParticleLoginOptions): Promise<void>;
    loginWithToken(token: string): void;
    setOAuthConfig(id: string, secret: string): void;
    logout(): void;
    isAuthenticated(): boolean;
    accessToken(): string;
    listDevices(): Promise<Array<TNSParticleDevice>>;
    publish(name: string, data: string, isPrivate: boolean, ttl?: number): Promise<void>;
    subscribe(prefix: string, eventHandler: (event: TNSParticleEvent) => void): void;
    unsubscribe(prefix: string): void;
    startDeviceSetupWizard(): Promise<boolean>;
    getDeviceSetupCustomizer(): any;
}
